<template>
  <div class="custom-crud-page">
    <el-bus-crud ref="crud" v-bind="crudConfig"></el-bus-crud>
  </div>
</template>

<script>
export default {
  data() {
    return {
      crudConfig: {
        url: 'flower/api/role/list',
        dialogNeedRequest: true,
        canEdit: (row) => {
          return row.isSys !== 'Y'
        },
        canDelete: (row) => {
          return row.isSys !== 'Y'
        },
        beforeOpen(row, isNew) {
          if (!isNew) {
            row.menuIdsView = row.menuIds
            row.roleDescription = row.roleDesc
          }
        },
        dialogAttrs: {
          destroyOnClose: true,
        },
        columns: [
          { label: '序号', type: 'index' },
          { label: '角色名称', prop: 'roleName' },
          { label: '角色描述', prop: 'roleDesc' },
          { label: '创建时间', prop: 'createdDate' },
        ],
        form: [
          {
            label: '角色名称：',
            id: 'roleName',
            type: 'input',
            rules: [
              { required: true, message: '请输入角色名称', trigger: 'blur' },
              { min: 1, max: 50, message: '要求长度不大于50字符' },
            ],
          },
          {
            label: '角色描述：',
            id: 'roleDesc',
            type: 'input',
            rules: { min: 0, max: 100, message: '要求长度不大于100字符' },
          },
          {
            label: '菜单权限',
            id: 'menuIds',
            component: 'base-role-permission-tree',
            rules: {
              required: true,
              type: 'array',
              message: '请至少选择一个菜单权限',
              trigger: 'change',
            },
            hidden: (row, item, mode) => mode === 'view',
          },
          {
            label: '菜单权限',
            id: 'menuIdsView',
            component: 'base-role-permission-tree',
            hidden: (row, item, mode) => mode !== 'view',
            forceDisabled: true,
          },
        ],
      },
    }
  },
  head() {
    return {
      title: '角色管理',
    }
  },
}
</script>
